
unit PYVM
{
	public link [#.code uint16*?] inslist;
	
	//PCָʼָһҪִеַָ
	uint16 PC;
	
	
	//ݶջ
	[uint16*10] stack;
	
	//SPָԪδԪ
	uint16 SP;
	
	//֡
	uint16 FS;
	//ֲջ (=FS+2)
	uint16 VS;
	
	uint16 data;
	
	[uint16*50] Frame;
	uint16 FStart;
	
	[int32*RAMLength] RAM;
	const uint16 RAMLength = 30;
	
	//---------------------------------------------------
	//ʼ
	public void Init()
	{
		PC = 0;
		SP = 0;
		FStart = 0;
		
		FS = 8;
		VS = FS + 2;
	}
	//---------------------------------------------------
	//ֽ
	public void Run()
	{
		Init();
		
		forever {
			uint16 code = inslist[PC];
			PC += 1;
			data = inslist[PC];
			PC += 1;
			
			switch( code ) {
				== c_LOAD_CONST:	LOAD_CONST(); break;
				== c_LOAD_FAST:	LOAD_FAST(); break;
				== c_STORE_FAST:	STORE_FAST(); break;
				== c_BINARY_ADD:	BINARY_ADD(); break;
				== c_POP_JUMP_IF_FALSE:	POP_JUMP_IF_FALSE(); break;
				== c_JUMP_FORWARD:	JUMP_FORWARD(); break;
				== c_COMPARE_OP:		COMPARE_OP(); break;
				== c_UNARY_NEGATIVE:	UNARY_NEGATIVE(); break;
				== c_SETUP_LOOP:		SETUP_LOOP(); break;
				== c_JUMP_ABSOLUTE:	JUMP_ABSOLUTE(); break;
				== c_POP_BLOCK:		POP_BLOCK(); break;
				== c_LOAD_GLOBAL:		LOAD_GLOBAL(); break;
				== c_CALL_FUNCTION:	CALL_FUNCTION(); break;
				== c_RETURN_VALUE:	RETURN_VALUE(); break;
				default:	break;
			}
			
			temp( PC );
			
			if( FS == 0 ) {
				break;
			}
		}
	}
	//һδõڴ
	uint16 Malloc()
	{
		for( uint16 i = 2; i < RAMLength; i += 2 ) {
			uint32 d = (uint)RAM[i];
			if( d.0(uint16) == 0 ) {
				d.0(uint16) = 0xFFFF;
				RAM[i] = (int)d;
				return i;
			}
		}
	}
	//Ӷջеһ
	uint16 Pop()
	{
		SP -= 1;
		uint16 d = stack[SP];
		
		uint32 da = (uint)RAM[d];
		if( da.0(uint16) == 0xFFFF ) {
			da.0(uint16) = 0;
			RAM[d] = (int)da;
		}
		return d;
	}
	public void temp( uint32 d )
	{
		//#.Ϣʾ.ڵ_е_ǰʾ_( 1, 4, (int)d );
		#.ʱ.ʱ_( 0.1s );
	}
	//=================================================================================
	
	public void LOAD_CONST()
	{
		uint16 i = Malloc();
		RAM[i+1] = (int)data;
		stack[SP] = i;
		SP += 1;
	}
	
	public void LOAD_FAST()
	{
		stack[SP] = Frame[data];
		SP += 1;
	}
	
	public void LOAD_GLOBAL()
	{
		stack[SP] = Frame[data];
		SP += 1;
	}
	
	public void STORE_FAST()
	{
		SP -= 1;
		uint16 d = stack[SP];
		
		uint16 addr = Frame[data];
		if( addr != 0 ) {
			RAM[addr] -= 1;
		}
		
		Frame[data] = d;
		
		uint32 da = (uint)RAM[d];
		if( da.0(uint16) == 0xFFFF ) {
			da.0(uint16) = 1;
			RAM[d] = (int)da;
		}
	}
	
	public void CALL_FUNCTION()
	{
		//浱ǰϢ
		uint16 temp = FS;
		FS += 4;
		VS = FS + 2;
		Frame[FS] = temp;
		Frame[FS+1] = PC;
		
		//ȡĿ꺯ַ
		uint16 a1 = Pop();
		int32 d = RAM[a1+1];
		PC = (uint16)(uint)d;
	}
	
	public void RETURN_VALUE()
	{
		PC = Frame[FS+1];
		FS = Frame[FS];
		VS = FS + 2;
	}
	
	public void BINARY_ADD()
	{
		uint16 a1 = Pop();
		uint16 a2 = Pop();
		
		int32 d = RAM[a1+1] + RAM[a2+1];
		uint16 i = Malloc();
		RAM[i+1] = d;
		stack[SP] = i;
		SP += 1;
	}
	
	public void POP_JUMP_IF_FALSE()
	{
		uint16 a1 = Pop();
		
		if( RAM[a1+1] == 0 ) {
			PC = data;
		}
	}
	
	public void JUMP_FORWARD()
	{
		PC = data;
	}
	
	public void UNARY_NEGATIVE()
	{
		uint16 a1 = Pop();
		
		int32 d = -RAM[a1+1];
		
		uint16 i = Malloc();
		RAM[i+1] = d;
		stack[SP] = i;
		SP += 1;
	}
	
	public void COMPARE_OP()
	{
		uint16 a1 = Pop();
		uint16 a2 = Pop();
		
		int32 d = 0;
		
		if( data == 0 ) {
			if( RAM[a2+1] < RAM[a1+1] ) {
				d = 1;
			}
		}
		if( data == 1 ) {
			if( RAM[a2+1] <= RAM[a1+1] ) {
				d = 1;
			}
		}
		if( data == 2 ) {
			if( RAM[a2+1] == RAM[a1+1] ) {
				d = 1;
			}
		}
		if( data == 3 ) {
			if( RAM[a2+1] != RAM[a1+1] ) {
				d = 1;
			}
		}
		if( data == 4 ) {
			if( RAM[a2+1] > RAM[a1+1] ) {
				d = 1;
			}
		}
		if( data == 5 ) {
			if( RAM[a2+1] >= RAM[a1+1] ) {
				d = 1;
			}
		}
		uint16 i = Malloc();
		RAM[i+1] = d;
		stack[SP] = i;
		SP += 1;
	}
	
	public void SETUP_LOOP()
	{
		
	}
	
	public void JUMP_ABSOLUTE()
	{
		PC = data;
	}
	
	public void POP_BLOCK()
	{
		
	}
	
	//---------------------------------------------------
	
	const uint16 c_LOAD_CONST = 1;
	const uint16 c_BINARY_ADD = 2;
	const uint16 c_LOAD_FAST = 3;
	const uint16 c_STORE_FAST = 4;
	const uint16 c_POP_JUMP_IF_FALSE = 5;
	const uint16 c_JUMP_FORWARD = 6;
	const uint16 c_COMPARE_OP = 7;
	const uint16 c_UNARY_NEGATIVE = 8;
	const uint16 c_SETUP_LOOP = 9;
	const uint16 c_JUMP_ABSOLUTE = 10;
	const uint16 c_POP_BLOCK = 11;
	const uint16 c_LOAD_GLOBAL = 12;
	const uint16 c_CALL_FUNCTION = 13;
	const uint16 c_RETURN_VALUE = 14;
}




